library cork.mirrors;

import 'package:cork/interface.dart';
export 'package:cork/interface.dart';

import 'package:cork/src/injector.dart';
import 'package:cork/src/mirrors/utils.dart';

/// A mirrors-based implementation of [ObjectGraph].
class DynamicObjectGraph implements ObjectGraph {
  final Injector _injector;

  factory DynamicObjectGraph.fromComponent(Type component) {
    return new DynamicObjectGraph._(new Injector(extract(component)));
  }

  DynamicObjectGraph._(this._injector);

  @override
  create(Type component) => _injector.get(component);
}
