library cork.test.injector_test;

import 'package:cork/src/injector.dart';
import 'package:guinness/guinness.dart';

void main() {
  describe('Injector', () {
    Injector injector;

    beforeEach(() {
      injector = new Injector({
        Object: new FakeFactory()
      });
    });

    it('creates and returns an instance by type, as a singleton', () {
      final fooA = injector.get(Object);
      final fooB = injector.get(Object);
      expect(fooA).toBe(fooB);
    });
  });
}

class FakeFactory implements TypeFactory {
  @override
  call([_]) => new Object();

  @override
  final parameterTypes = const [];
}
