library cork.test.mirrors.dynamic_factory_test;

import 'dart:mirrors';

import 'package:cork/src/mirrors/utils.dart';
import 'package:guinness/guinness.dart';

void main() {
  describe('DynamicFactory', () {
    DynamicTypeFactory<Foo> factory;

    beforeEach(() {
      factory = new DynamicTypeFactory<Foo>(reflectClass(Foo));
    });

    it('creates a new instance when called', () {
      expect(factory([{}, ''])).toBeAnInstanceOf(Foo);
    });

    it('returns an iterable of parameter types', () {
      expect(factory.parameterTypes).toEqual([Map, String]);
    });
  });
}

class Foo {
  Foo(Map map, String string) {}
}
