library cork.test.mirrors_integration_test;

import 'package:cork/mirrors.dart';
import 'package:guinness/guinness.dart';

void main() {
  describe('DynamicObjectGraph', () {
    ObjectGraph objectGraph;

    beforeEach(() {
      objectGraph = new DynamicObjectGraph.fromComponent(FooComponent);
    });

    it('can create the component with all dependencies injected', () {
      FooComponent foo = objectGraph.create(FooComponent);
      expect(foo.bar).toBeAnInstanceOf(Bar);
      expect(foo.bar.baz).toBeAnInstanceOf(Baz);
    });
  });
}

@Component(const [BarModule])
class FooComponent {
  final Bar bar;

  FooComponent(this.bar);
}

@Module(const [Bar, Baz])
class BarModule {}

@Inject()
class Bar {
  final Baz baz;

  Bar(this.baz);
}

@Inject()
class Baz {}
